<?php
require dirname(__DIR__, 2).'/lib/vendor/autoload.php';
use PayMoney\Api\Amount;
use PayMoney\Api\Payer;
use PayMoney\Api\Payment;
use PayMoney\Api\RedirectUrls;
use PayMoney\Api\Transaction;
class PayplantationPaymentModuleFrontController extends ModuleFrontController
{
    public function init()
    {
        parent::init();

        if (isset($_GET['action']) && 'redirect' == $_GET['action']) {
            $this->redirect();
        } elseif (isset($_GET['action']) && 'callback' == $_GET['action']) {
            $this->callback();
        } else {
            Tools::redirect($this->context->link->getPageLink('order', true));
        }
    }

    public function callback()
    {
       if(isset($_GET['order_id']) && isset($_GET['token'])){
            $encoded = json_encode($_GET['token']);
            $encoded = substr($encoded,1);
            $decoded = json_decode(base64_decode($encoded), TRUE);
            $cart = new Cart($_GET['order_id']);
            $total = (float) $cart->getOrderTotal(true, Cart::BOTH);
            $currency = $cart->id_currency;
            $baseUrl = Context::getContext()->shop->getBaseURL(true);
            if (isset($this->module->id)) {
                $plantationId = $this->module->id;
            } else {
                $plantationId = $this->context->controller->module->id;
            }
            if ($decoded["status"] == 200)
             {
               $tranId = $decoded["transaction_id"];
               try{
                    $this->module->validateOrder(
                                (int) $cart->id,
                                2,
                                $total,
                                $this->module->displayName,
                                null,
                                ['transaction_id' => $tranId],
                                (int) $cart->id_currency,
                                false,
                                $cart->secure_key
                        );
               }catch(Exception $e){

               }

               $success = $baseUrl.'index.php?controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$plantationId.'&key='.$this->context->customer->secure_key;
               Tools::redirect($success);
             }else{
                if (!isset($decoded["status"])) {
                  $decoded["status"] = 'failed';
                }
               $message = 'the payment failed Status :'.$decoded["status"];
                
                Context::getContext()->smarty->assign([
                        'error_msg' => $message,
                         ]);
                $this->setTemplate('module:payplantation/views/templates/front/errors.tpl');
                return;
               
             }
    
        }
           
        $this->setTemplate('module:payplantation/views/templates/front/payment.tpl');
    }

    public function redirect()
    {
        $client_id = Tools::getValue('plantation_id', Configuration::get('plantation_id'));
        $client_secret =  Tools::getValue('plantation_secret', Configuration::get('plantation_secret'));
        $cart = $this->context->cart;
        $reference = $this->context->cart->id;
        $currency = $this->context->currency;
        $currency = $cart->id_currency;
        $total = (float) $cart->getOrderTotal(true, Cart::BOTH);
        $currency = Currency::getCurrencyInstance((int) $currency)->iso_code;
        $total = (float) $cart->getOrderTotal(true, Cart::BOTH);
        //Payer Object
        $payer = new Payer();
        $payer->setPaymentMethod('Payplantation');
        $amountIns = new Amount();
        $amountIns->setTotal($total)->setCurrency($currency); 
        $trans = new Transaction();
        $trans->setAmount($amountIns);
        $succsesUrl = $this->context->link->getModuleLink($this->module->name, 'payment', ['action' => 'callback','order_id' => $reference ,'token' => ''], true);

        $cancelUrl = $this->context->link->getPageLink('order', true);
        $urls = new RedirectUrls();
        $urls->setSuccessUrl($succsesUrl)   
        ->setCancelUrl($cancelUrl);
        //Payment Object
        $payment = new Payment();
        $payment->setCredentials([ 
            'client_id'     => $client_id, 
            'client_secret' => $client_secret,
        ])
        ->setRedirectUrls($urls)
        ->setPayer($payer)
        ->setTransaction($trans);
        try {
            
            $payment->create(); //create payment
  
            Tools::redirect($payment->getApprovedUrl());

        }
        catch (\Exception $ex)
        {

            Context::getContext()->smarty->assign([
            'error_msg' => $ex->getMessage(),
             ]);
            $this->setTemplate('module:payplantation/views/templates/front/errors.tpl');
        }

    }
}
